%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function [Converted_JT_Counter, Aborted_Conversion_Counter] = Convert_RBE2SEQ_To_PL(Fastener_Index, Layer)

global ErrCode;

global DB_FASTENERS;

% Инициализация счетчиков
Converted_JT_Counter = 0;
Aborted_Conversion_Counter = 0;

% Проверка исходной присоединенной топологии на центрованность
[Test_Result, Center_Node_ID] = Plate_RBE2_Seq_Centered_Test(Fastener_Index, Layer);

if (ErrCode < 0)
    return;
end

% Если присоединенная топология не центрованная, то отменяем конвертацию
if (Test_Result ~= 1)
    Aborted_Conversion_Counter = 1;
    return;
end

% Удаление RBE2
MPC_list = DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.MPC_ID;

Append_To_Output(PCL_MPC_Delete(MPC_list));
DB_MPC_Delete(MPC_list);

if (ErrCode < 0)
    return;
end

% Ассоциирование элементов с узлом болта
Element_list = DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list;
Node_list = Center_Node_ID;
Target_Node_list = DB_FASTENERS{Fastener_Index}.Joint_nodes(Layer);

Append_To_Output(PCL_Elm_Modify_Conn(Element_list, Node_list, Target_Node_list));
DB_Elm_Modify_Conn(Element_list, Node_list, Target_Node_list);

if (ErrCode < 0)
    return;
end

% Удаление узла
Node_list = Center_Node_ID;

Append_To_Output(PCL_Node_Delete(Node_list));
DB_Node_Delete(Node_list);

if (ErrCode < 0)
    return;
end

% Внесение изменений в базу данных крепежа
DB_FASTENERS{Fastener_Index}.Joint_topology{Layer} = 'plate';
DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.MPC_ID = [];

% Обновление счетчика
Converted_JT_Counter = 1;
